diff --git a/hubs/static/client/app/widgets/halp/Widget.js b/hubs/static/client/app/widgets/halp/Widget.js
new file mode 100644
index 0000000..099adb2
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/Widget.js
@@ -0,0 +1,213 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import {
+  widgetDidUpdate,
+  widgetWillUpdate
+  } from "../../core/actions/widget";
+import HubsList from './HubsList';
+import ModalRequest from './ModalRequest';
+import ModalAllRequests from './ModalAllRequests';
+import Request from './Request';
+import WidgetChrome from '../../components/WidgetChrome';
+import Spinner from "../../components/Spinner";
+import "./halp.css";
+
+
+const messages = defineMessages({
+  no_request: {
+    id: "hubs.widgets.halp.no_request",
+    defaultMessage: "No request for now."
+  },
+  view_more: {
+    id: "hubs.widgets.halp.view_more",
+    defaultMessage: "View more"
+  },
+  zoom_title: {
+    id: "hubs.widgets.halp.zoom.title",
+    defaultMessage: "Help request"
+  },
+  search_title: {
+    id: "hubs.widgets.halp.search.title",
+    defaultMessage: "All Help Requests"
+  },
+});
+
+
+export default class Widget extends React.Component {
+
+  propTypes: {
+    widget: PropTypes.object.isRequired,
+    editMode: PropTypes.bool,
+    needsUpdate: PropTypes.bool,
+  }
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      requests: [],
+      inactiveHubs: [],
+      zoomedRequest: null,
+      allRequestsOpen: false,
+      isLoading: false
+    };
+    this.zoomOnRequest = this.zoomOnRequest.bind(this);
+    this.onZoomClose = this.onZoomClose.bind(this);
+    this.openAllRequests = this.openAllRequests.bind(this);
+    this.onAllRequestsClose = this.onAllRequestsClose.bind(this);
+    this.onHubClick = this.onHubClick.bind(this);
+  }
+
+  componentDidMount() {
+    if (!this.props.editMode) {
+      this.loadFromServer();
+    }
+  }
+
+  componentWillUnmount() {
+    this.serverRequest.abort();
+  }
+
+  componentDidUpdate(prevProps, prevState) {
+    if (this.props.needsUpdate && !this.props.editMode && !this.state.isLoading) {
+      this.loadFromServer();
+    }
+  }
+
+  loadFromServer() {
+    let hubs = this.props.widget.config.hubs || [];
+    hubs = hubs.filter((hub) => (this.state.inactiveHubs.indexOf(hub) === -1));
+    const params = hubs.length > 0 ? $.param({hubs}, true) : "hubs=";
+    this.props.dispatch(widgetWillUpdate(this.props.widget.idx));
+    this.setState({isLoading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.widget.urls.data,
+      method: 'GET',
+      data: params,
+      dataType: 'json',
+      cache: false,
+      success: (data) => {
+        this.setState({
+          requests: data.data.requests,
+          isLoading: false
+        },
+          () => (
+            this.props.dispatch(widgetDidUpdate(this.props.widget.idx))
+          )
+        );
+      },
+      error: (xhr, status, err) => {
+        console.error(this.props.widget.urls.data, status, err.toString());
+        this.setState({isLoading: false});
+      }
+    });
+  }
+
+  zoomOnRequest(request) {
+    this.setState({
+      zoomedRequest: request,
+      allRequestsOpen: false,
+      });
+  }
+  onZoomClose() {
+    this.setState({zoomedRequest: null});
+  }
+
+  openAllRequests(e) {
+    e.preventDefault();
+    this.setState({allRequestsOpen: true});
+  }
+  onAllRequestsClose() {
+    this.setState({allRequestsOpen: false});
+  }
+
+  onHubClick(hubName) {
+    var newInactiveHubs = this.state.inactiveHubs.slice(),
+        inactiveIndex = this.state.inactiveHubs.indexOf(hubName);
+    if (inactiveIndex === -1) {
+      newInactiveHubs.push(hubName);
+    } else {
+      newInactiveHubs.splice(inactiveIndex, 1);
+    }
+    this.setState(
+      { inactiveHubs: newInactiveHubs },
+      this.loadFromServer);
+  }
+
+  render() {
+    let requestNodes;
+    if (this.state.requests.length === 0) {
+      requestNodes = (
+        <p className="no-request">
+          <FormattedMessage {...messages.no_request} />
+        </p>
+        );
+    } else {
+      let previousDate = null;
+      requestNodes = this.state.requests.map(function(request, idx) {
+        const showDate = (request.date !== previousDate);
+        previousDate = request.date;
+        return (
+          <Request
+            request={request}
+            showdate={showDate}
+            onZoomRequest={this.zoomOnRequest}
+            key={idx} />
+        );
+      }.bind(this));
+    }
+    let hubs = this.props.widget.config.hubs || [];
+    hubs = hubs.map(function(hub) {
+      return {
+        name: hub,
+        active: (this.state.inactiveHubs.indexOf(hub) === -1)
+      }
+    }.bind(this));
+    return (
+      <WidgetChrome
+        widget={this.props.widget}
+        editMode={this.props.editMode}
+        >
+        <div className="widget-halp">
+          <HubsList
+            hubs={hubs}
+            onHubClick={this.onHubClick}
+            />
+          { this.state.isLoading ?
+              <Spinner />
+            :
+              <div className="requests">
+                {requestNodes}
+              </div>
+          }
+          <div className="view-more text-muted">
+            <button className="btn btn-secondary" onClick={this.openAllRequests}>
+              <FormattedMessage {...messages.view_more} />
+              &nbsp; <span className="fa fa-chevron-right" aria-hidden="true"></span>
+            </button>
+          </div>
+          { this.state.zoomedRequest &&
+          <ModalRequest
+            open={this.state.zoomedRequest !== null}
+            data={this.state.zoomedRequest}
+            title={<FormattedMessage {...messages.zoom_title} />}
+            onCloseClicked={this.onZoomClose}
+            />
+          }
+          { this.state.allRequestsOpen &&
+            <ModalAllRequests
+              onCloseClicked={this.onAllRequestsClose}
+              onZoomRequest={this.zoomOnRequest}
+              title={<FormattedMessage {...messages.search_title} />}
+              urls={this.props.widget.urls}
+              hubs={hubs}
+              />
+          }
+        </div>
+      </WidgetChrome>
+    );
+  }
+}
diff --git a/hubs/static/client/app/widgets/halp/getRequestView.js b/hubs/static/client/app/widgets/halp/getRequestView.js
new file mode 100644
index 0000000..13e3d17
--- /dev/null
+++ b/hubs/static/client/app/widgets/halp/getRequestView.js
@@ -0,0 +1,64 @@
+import React from 'react';
+import { FormattedMessage, defineMessages } from 'react-intl';
+import Linkify from 'react-linkify';
+
+
+const messages = defineMessages({
+  req_no_text: {
+    id: "hubs.widgets.halp.req_no_text",
+    defaultMessage: "(no message)"
+  },
+});
+
+
+export default function getRequestView(request, openCallback) {
+    var openButton = "";
+    if (openCallback) {
+      openButton = (
+        <div className="media-right media-middle">
+          <button className="btn btn-secondary btn-sm" onClick={openCallback}>
+            <span className="fa fa-chevron-right" aria-hidden="true"></span>
+          </button>
+        </div>
+      );
+    }
+    return (
+      <div className="request row">
+        <div className="hub col-sm-6">
+          <span>@{request.hub}</span>
+        </div>
+        <div className="channel col-sm-6">
+          {request.channel}
+        </div>
+        <div className="text col-sm-12">
+          { request.text ?
+            <Linkify>{'"'}{request.text}{'"'}</Linkify>
+          :
+            <em><FormattedMessage {...messages.req_no_text } /></em>
+          }
+        </div>
+        { request.url ?
+        <div className="url col-sm-12">
+          <a href={request.url}>
+            {request.url.replace(/^https?:\/\//, '')}
+          </a>
+        </div>
+        : null }
+        <div className="author media col-sm-12">
+          <a
+            href={request.author.url} target="_blank"
+            className="d-flex mr-3"
+            >
+            <img className="square-32 img-circle"
+                 src={request.author.avatar} />
+          </a>
+          <div className="media-body align-self-center">
+            <a href={request.author.url}>
+              {request.author.name}
+            </a>
+          </div>
+          {openButton}
+        </div>
+      </div>
+    );
+}
diff --git a/hubs/static/client/setupTests.js b/hubs/static/client/setupTests.js
new file mode 100644
index 0000000..d74d0e0
--- /dev/null
+++ b/hubs/static/client/setupTests.js
@@ -0,0 +1,4 @@
+import Enzyme from 'enzyme';
+import Adapter from 'enzyme-adapter-react-15';
+
+Enzyme.configure({ adapter: new Adapter() });
diff --git a/hubs/static/client/webpack.common.js b/hubs/static/client/webpack.common.js
new file mode 100644
index 0000000..e060cd7
--- /dev/null
+++ b/hubs/static/client/webpack.common.js
@@ -0,0 +1,61 @@
+const webpack = require('webpack');
+const path = require('path');
+const CleanWebpackPlugin = require('clean-webpack-plugin');
+
+const PATHS = {
+  app: path.join(__dirname, 'app'),
+  build: path.join(__dirname, '..', 'js', 'build')
+};
+
+module.exports = {
+  entry: {
+    Hubs: path.join(PATHS.app, 'core', 'index.js'),
+  },
+  output: {
+    path: PATHS.build,
+    filename: '[name].js',
+    chunkFilename: '[name].[chunkhash:8].bundle.js',
+    publicPath: "/static/js/build/", // TODO: https://webpack.js.org/guides/public-path/
+    library: 'Hubs',
+  },
+  externals: {
+    'jquery': 'jQuery',
+    'react': 'React',
+    'react-dom': 'ReactDOM',
+  },
+  module: {
+    rules: [
+    {
+      test: /\.jsx?$/,
+      enforce: 'pre',
+      loader: 'eslint-loader',
+      options: {
+        emitWarning: true,
+      },
+      include : PATHS.app
+    },
+    {
+      test : /\.jsx?$/,
+      loader : 'babel-loader',
+      options: {
+        cacheDirectory: true,
+      },
+      exclude: /node_modules/,
+      include : PATHS.app
+    },
+    {
+      test: /\.(png|svg|jpg|gif)$/,
+      use: [ 'file-loader' ]
+    }
+    ]
+  },
+  plugins: [
+    new CleanWebpackPlugin(
+      [PATHS.build], {
+        allowExternal: true,
+        exclude: ['.gitignore']
+      }
+    ),
+    new webpack.optimize.CommonsChunkPlugin("common")
+  ]
+};
diff --git a/hubs/static/client/webpack.dev.js b/hubs/static/client/webpack.dev.js
new file mode 100644
index 0000000..01164e2
--- /dev/null
+++ b/hubs/static/client/webpack.dev.js
@@ -0,0 +1,17 @@
+const merge = require('webpack-merge');
+const common = require('./webpack.common.js');
+
+module.exports = merge(common, {
+  devtool: 'inline-source-map',
+  module: {
+    rules: [
+    {
+      test: /\.css$/,
+      use: [
+        'style-loader',
+        'css-loader'
+      ]
+    }
+    ]
+  },
+});
diff --git a/hubs/static/client/webpack.prod.js b/hubs/static/client/webpack.prod.js
new file mode 100644
index 0000000..5db728b
--- /dev/null
+++ b/hubs/static/client/webpack.prod.js
@@ -0,0 +1,34 @@
+const webpack = require('webpack');
+const merge = require('webpack-merge');
+const UglifyJSPlugin = require('uglifyjs-webpack-plugin');
+const ExtractTextPlugin = require("extract-text-webpack-plugin");
+const common = require('./webpack.common.js');
+
+module.exports = merge(common, {
+  devtool: 'source-map',
+  module: {
+    rules: [
+    {
+      test: /\.css$/,
+      use: ExtractTextPlugin.extract({
+        fallback: "style-loader",
+        use: "css-loader"
+      })
+    }
+    ]
+  },
+  plugins: [
+    new ExtractTextPlugin({
+      filename: "style.css",
+      allChunks: true,
+    }),
+    new UglifyJSPlugin({
+      sourceMap: true
+    }),
+    new webpack.DefinePlugin({
+      'process.env': {
+        'NODE_ENV': JSON.stringify('production')
+      }
+    })
+  ]
+})
diff --git a/tox.ini b/tox.ini
index a6609a0..c7e54cf 100644
--- a/tox.ini
+++ b/tox.ini
@@ -52,4 +52,4 @@ commands =
 
 [flake8]
 show-source = True
-exclude = .git,.tox,dist,*egg,doc
+exclude = .git,.tox,dist,*egg,doc,node_modules

